#!/bin/bash

# $Id$
# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

# Changes the NTP server to the host specified.
# Called by the maintenance console

set -e

CONF_FILE=/etc/ntp.conf

echo

while [[ 1 ]]
do
    read -r -p "Enter NTP server IP address/FQDN:" HOST

    if [[ $HOST =~ ([0-9]{1,3}\.){3}([0-9]){1,3} ]] || [[ $HOST =~ .*:.* ]] ; then
        ADDR=$HOST
        break
    else
        if ! host $HOST > /dev/null 2>&1; then
            echo "Host \"$HOST\" not found. Enter a valid IP address/FQDN."
            while [[ 1 ]]
            do
                read -r -p "Do you wish to continue? (y/n):" answer
                if [ "$answer" == "n" ]  || [ "$answer" == "N" ]; then
                    echo
                    echo "Changes to NTP server cancelled."
                    echo
                    exit
                else
                    if [ "$answer" == "y" ] || [ "$answer" == "Y" ]; then
                        break
                    fi
                fi
            done
        else
            ADDR=`host $HOST | grep -m1 'has address' | sed 's/^.* has address \(.*\)$/\1/'`
            break
        fi
    fi
done


# Change the IP on the following lines of /etc/ntp.conf:
# server 192.43.244.18 iburst
# restrict 192.43.244.18 nomodify notrap nopeer noquery
sed --in-place=.`date "+%Y-%m-%d_%H:%M"` "/^server 98/ a server $ADDR iburst" $CONF_FILE
sed --in-place=.`date "+%Y-%m-%d_%H:%M"` "/^restrict 98.* nomodify notrap nopeer noquery/ a restrict $ADDR nomodify notrap nopeer noquery" $CONF_FILE

# Restart NTP server
service ntp restart > /dev/null 2>&1

echo
echo "NTP server added : $HOST."

