#!/bin/bash

# $Id: $
# Copyright (c) 2018 NetApp, Inc.
# All rights reserved.

# Modifies log levels to INFO/DEBUG/TRACE/ERROR.
#
#
# Enforcement is as follows:
#     ownership:   root:root
#     permissions: -r-x------
#     The maintenance user is given sudo access to this script.

set -e

# Note that /home/maint/scripts/commonfunctions.sh
# needs to be owned by root and writable only by root for this to be secure
. /home/maint/scripts/commonfunctions.sh

function main() {
    if [[ $# -eq 1 ]] ; then
        
       sed -i -e "/rootLogger.level=/ s/=[^,]*/=$1/" /opt/netapp/vpserver/conf/log4j2.properties
       sed -i -e "/logger.netapp.level=/ s/=[^,]*/=$1/" /opt/netapp/vpserver/conf/log4j2.properties
       sed -i -e "/logger.NetappLogger.level=/ s/=[^,]*/=$1/" /opt/netapp/vpserver/conf/log4j2.properties

    fi

}

main "$@"
