#!/bin/bash

# $Id: $
# Copyright (c) 2018 NetApp, Inc.
# All rights reserved.

# Modifies log levels to INFO/DEBUG/TRACE/ERROR.
#
#
# Enforcement is as follows:
#     ownership:   root:root
#     permissions: -r-x------
#     The maintenance user is given sudo access to this script.

set -e

# Note that /home/maint/scripts/commonfunctions.sh
# needs to be owned by root and writable only by root for this to be secure
. /home/maint/scripts/commonfunctions.sh

function main() {
    if [[ $# -eq 1 ]] ; then
        sed -i -e "/log4j.appender.kaminoLog.Threshold=/ s/=.*/=$1/" /opt/netapp/vscserver/etc/kamino/log4j.properties
        sed -i -e "/log4j.rootLogger=/ s/=.*,/=$1,/" /opt/netapp/vscserver/etc/kamino/log4j.properties
        sed -i -e "/log4j.logger.com.netapp=/ s/=.*,/=$1,/" /opt/netapp/vscserver/etc/kamino/log4j.properties
        sed -i -e "/log4j.logger.com.netapp.nvpf.subplugin.kamino=/ s/=.*,/=$1,/" /opt/netapp/vscserver/etc/kamino/log4j.properties
        sed -i -e "/logger.netapp.level=/ s/=[^,]*/=$1/" /opt/netapp/vscserver/etc/nvpf-subplugin-vp/log4j2.properties
        # /tmp/logger will be used as the working directory while changing the LOG level
        if [ -d /tmp/logger ]; then
            rm -rf /tmp/logger
        fi
        mkdir -p /tmp/logger
        # Capturing the backup of vsc.war before we make any changes
        if [ ! -d /tmp/orig ]; then
            mkdir -p /tmp/orig
        fi
        cp /opt/netapp/vscserver/subplugins/deploy/vsc.war /tmp/logger/
        cp /opt/netapp/vscserver/subplugins/deploy/vsc.war /tmp/orig/
        unzip /tmp/logger/vsc.war -d /tmp/logger/ > /tmp/logger/extract.txt
        sed -i -e "/log4j.appender.LOG.Threshold=/ s/=.*/=$1/" /tmp/logger/WEB-INF/classes/log4j.properties
        sed -i -e "/log4j.appender.DISCOVERY.Threshold=/ s/=.*/=$1/" /tmp/logger/WEB-INF/classes/log4j.properties
        rm /tmp/logger/vsc.war
        cd /tmp/logger
        zip -r vsc.war META-INF/ WEB-INF/ >> /tmp/logger/extract.txt
        cp /tmp/logger/vsc.war /opt/netapp/vscserver/subplugins/deploy/vsc.war
        chmod 644 /opt/netapp/vscserver/subplugins/deploy/vsc.war
        chown vscserver:vscservergroup /opt/netapp/vscserver/subplugins/deploy/vsc.war
        rm -rf /tmp/logger
    fi

}

main "$@"
