#!/bin/bash
# Displays a list of available timezones

TZFILE=/usr/share/zoneinfo/zone.tab
# Etc contains "timezones" of the form GMT+xx or GMT-xx
# and things like Etc/UTC (the default timezone).
# These do not appear in zone.tab, but we want to include them
# Since 1) Etc/UTC is the default and 2) Java also recognizes them.
TZETC=/usr/share/zoneinfo/Etc

# Frome zone.tab:
# This file contains a table with the following columns:
# 1.  ISO 3166 2-character country code.  See the file `iso3166.tab'.
# 2.  Latitude and longitude of the zone's principal location
#     in ISO 6709 sign-degrees-minutes-seconds format,
#     either +-DDMM+-DDDMM or +-DDMMSS+-DDDMMSS,
#     first latitude (+ is north), then longitude (+ is east).
# 3.  Zone name used in value of TZ environment variable.
# 4.  Comments; present if and only if the country has multiple rows.
(find $TZETC -type f | sed 's#/usr/share/zoneinfo/##g' && awk '/^#/ { next } {print $3}' $TZFILE) | sort
