#!/bin/bash

protcolToEnable=$1

function readProperty(){
	local PROP_VALUE=`cat $PROPERTY_FILE | grep  "^$PROP_KEY" | cut -d'=' -f2` 
	echo "$PROP_VALUE"
}
javalink=`which java`
javapath=`readlink -f $javalink`
javadir=`dirname $javapath`
javabin=`dirname $javadir`
PROPERTY_FILE=$javabin/conf/security/java.security
PROP_KEY='jdk.tls.disabledAlgorithms'
VALUE=$(readProperty)


function enableProtocol(){
	protocolList=""
	set -f                      # avoid globbing (expansion of *).
	array=(${VALUE//,/ })
	for i in "${!array[@]}"
	do
		if [ "${array[i]}" != "$protcolToEnable" ] 
		then
			if [ "$protocolList" == "" ]
			then
				protocolList="${array[i]}"
			else 
				protocolList="$protocolList, ${array[i]}"
			fi
		fi
	done
	
	
	sed -i "s/$PROP_KEY=$VALUE\/$PROP_KEY=$protocolList\/" "$PROPERTY_FILE"
}
enableProtocol
